//////////////////////////////////////////////////////////////////////////////////////////////////////////////


var selCards = {
    fullCard: ".full-card-overlay",
    overlay: ".card-overlay",
    cardContainer: ".open-card-container",
    //backgroundElements: "header, .actions-bar, aside, .sorting-container, main",
    backgroundElements: "header, .actions-bar, aside, main",
    btnOpenCard: ".btn-open-card",
    btnCloseCard: ".btn-close-card",
    btnSaveAsCustom: ".btn-save-custom",
    cardItem: ".card",
    removeFlag: "pending-removal",
    cardsFlaggedForRemoval: ".pending-removal",
    btnAddCard: ".btn-add-card",
    btnRemoveCard: ".btn-remove-card",
    btnRemoveCards: ".btn-remove-multiple-cards",
    selectedCard: ".card.item-selected",
    btnCommitRemove: ".btn-confirm-remove-dev, .btn-confirm-remove-devs",
    btnCommitAdd: ".btn-confirm-add-dev",
    visibleInnerCards: ".inner-card-container:visible",
    btnBackCard: ".btn-back-card-container",
    btnOpnDevCard: ".btn-open-device-card",
    btnOpnPtcCard: ".btn-open-patch-card",
    btnOpnThreatCard: ".btn-open-threat-card",
    btnOpnRepCard: ".btn-open-report-card",
    btnOpenDevExcCard: ".btn-open-device-exc-card",
    btnOpnGrpCard: ".btn-open-group-tree-card",
    btnOpnAlertCard: ".btn-open-alert-card",
    btnOpenTempAccessCard: ".btn-open-grant-temporary-access",
    tempAccessCard: ".temporary-access-card",
    //btnOpnNotCard: ".btn-open-notification-card > td:not(.cell-select)",
    btnOpenNotificationCard: ".btn-open-notification-card",
    btnOpenWidgetLibraryCard: ".btn-open-overview-widget-card",
    deviceCard: ".device-card",
    widgetLibraryCard: ".overview-widgets-card",
    patchCard: ".patch-card",
    threatCard: ".threat-card",
    reportCard: ".report-card",
    alertCard : ".alert-card",
    deviceExclusionCard: ".device-exclusion-card",
    groupTreeCard: ".group-tree-card",
    notificationCard: ".notification-card",
    innerCardIcon: ".card-type-container i",
    cardTabNamesList: ".inner-card-header .tabs-name-container ul li",
    cardTabNames: ".inner-card-header .tabs-name-container .btn-tog-tab",
    cardTabBodies: ".inner-card-body .tabs-container .tab",
    btnShowAffectedDevices: ".btn-show-affected-devices",
    btnShowAffectedDevicesThreat: ".btn-show-affected-devices-threat",
    btnTogTabs: ".tabs-name-container .btn-tog-tab",
    btnTogDeviceTab: ".tabs-name-container li[data-target='tab-devices'] .btn-tog-tab",
    cardTabs: ".tabs-container .tab",
    deviceTab: ".tabs-container .tab-devices",
    btnSetCredentials: ".btn-set-device-credentials",
    btnCloseDeviceCredentials: ".btn-close-device-credentials",
    btnClearDeviceCredentials: ".btn-clear-device-credentials",
    chkTree: ".chkbx-tree",
    devCredContainer: ".device-credentials-container",
    cardFocusArea: ".focus-area-control",
    outerCardNameIcn: ".outer-card-name i",
    btnMsgPrompt: ".btn-msg-prompt",
    btnRebootDevice: ".btn-reboot-device",
    btnShutdownDevice: ".btn-shutdown-device",
    btnConfReboot: ".btn-conf-device-reboot",
    btnConfShutdown: ".btn-conf-device-shutdown",
    setCredConfirm: "dev-card-tab-overview-set-credentials_confirm_btn",
    btnStartTour: ".btn-start-tour"
};

var asideClass,
    btnAffectedDevices = "btn-show-affected-devices",
    btnAffectedDevicesThreat = "btn-show-affected-devices-threat";


//////////////////////////////////////////////////////////////////////////////////////////////////////////////

function unbindKeypressToCard() {
    $(document).off("keydown");
}

//open card
//used for all cards
function openCard(targetCard, opInit) {
    //add background blur to .dynamics, header and .actions-bar
    function blurBackground() {
        $(selCards.backgroundElements).addClass("blur");
    }

    //select the first tab of a card before it opens
    function selectFirstTab(_targetCard, _opInit) {
        //toggle selected tab button
        $(_targetCard).find(selCards.cardTabNames).removeClass("active");
        $(_targetCard).find(selCards.cardTabNamesList).first().find("a").addClass("active");

        //toggle tab content visibility
        $(_targetCard).find(selCards.cardTabBodies).hide();
        $(_targetCard).find(selCards.cardTabBodies).first().show();

        // Make sure the service menu is not selected and it shows the original text and not any of the menu items
        // and icon is also original.
        $(selDeviceCard.deviceCardServicesMenuTitleText).text($(selDeviceCard.deviceCardHiddenServicesMenuTitle).text());
        $(selDeviceCard.deviceCardServicesMenuIcon).removeClass().addClass("icon icon-pictos-33");
        $(selDeviceCard.deviceCardServicesMenuTitle).removeClass('active');
    }

    //show targeted card + add class current to apply overlay background + zindex
    function showCard(_targetCard, _opInit) {
        $(selCards.overlay).removeClass("current");
        $(selCards.overlay + _targetCard).show().addClass("current");
        $(_targetCard).attr("data-cardorder", $(selCards.visibleInnerCards).length);
    }

    //initialise card pie charts
    function initialiseCardChart(_targetCard, _opInit) {
        switch (_targetCard) {
            case ".device-card":
                //InitialiseStorageChart();
                break;

            case ".patch-card":
                //InitialiseStateChart();
                break;

            default:
                console.log("Cards.js: No card charts to initialise.");
        }
    }

    //set card open history order
    //allows back button to determine to which card it goes back to
    function setCardOpenHistoryOrder(_targetCard, _opInit) {
        $(_targetCard).attr("data-cardorder", $(selCards.visibleInnerCards).length);
    }

    //check if operation initiator is device count
    //if yes, open patch card in devices tab
    function showAffectedDevices(_targetCard, _opInit) {
        if ($(_opInit).hasClass(btnAffectedDevices) || $(_opInit).hasClass(btnAffectedDevicesThreat)) {
            $(_targetCard).find(selCards.btnTogTabs).removeClass("active");
            $(_targetCard).find(selCards.btnTogDeviceTab).addClass("active");
            $(_targetCard).find(selCards.cardTabs).hide();
            $(_targetCard).find(selCards.deviceTab).show();
        }
    }

    function bindKeypressToCard() {
        $(document).off("keydown");
        $(document).on("keydown", function (e) {

            if (isReportsGroupTreeActive()) {
                $(".group-tree-card").removeClass("current").hide();
                $(".report-card.full-card-overlay").addClass("current");
            }

            else {
                if (e.which == 27) closeCards();
            }


        });
    }

    //notification card only
    //assigns notification severity icon
    if (targetCard == ".notification-card") {
        switch ($(opInit).parents("tr").data("severity")) {
            case "critical":
                $(selCards.notificationCard).find(selCards.innerCardIcon).removeClass().addClass("icon-pictos-364");
                $(selCards.notificationCard).find(selCards.outerCardNameIcn).removeClass().addClass("icon-pictos-364");
                break;

            case "warning":
                $(selCards.notificationCard).find(selCards.innerCardIcon).removeClass().addClass("icon-pictos-637");
                $(selCards.notificationCard).find(selCards.outerCardNameIcn).removeClass().addClass("icon-pictos-637");
                break;

            case "information": case "info":
                $(selCards.notificationCard).find(selCards.innerCardIcon).removeClass().addClass("icon-pictos-586");
                $(selCards.notificationCard).find(selCards.outerCardNameIcn).removeClass().addClass("icon-pictos-586");
                break;
        }

        //set notification to read
        $(opInit).parents("tr").attr("data-read", "true");
    }

    //blur background
    blurBackground();

    //select card's first tab
    selectFirstTab(targetCard, opInit);

    //show affected devices if opInit is device counter
    showAffectedDevices(targetCard, opInit)

    //show active card
    showCard(targetCard, opInit);

    $(selCards.overlay + targetCard).find(".general-filters-container.open").each(function () {
        toggleFiltersMenu($(this));
    });

    //initialise chart in general tab
    initialiseCardChart(targetCard, opInit);

    //set card open order
    setCardOpenHistoryOrder(targetCard, opInit);

    toggleBackButton();

    bindKeypressToCard();

}

//close all cards
function closeCards(opInit) {
    $(selCards.overlay).hide().removeClass("current");
    $(selCards.backgroundElements).removeClass("blur");
    $(selCards.overlay).removeAttr("data-cardorder");

    //Uncheck table select all
    $("#device-card-select-all").icheck('unchecked');

    if ($(opInit).parents(selCards.overlay).hasClass("group-tree-card")) {
        $(selCards.groupTreeCard).find(selCards.chkTree).fancytree(function (node) {
            node.setActive(false).setFocus(false).setSelected(false);
        });
    }

    unbindKeypressToCard();
}
//close specific cards
function closeCard(opInit) {
    var targetCardOverlay = $(opInit).parents(selCards.overlay),
        currentCardOrder = $(targetCardOverlay).data("cardorder"),
        prevCardOrder = currentCardOrder - 1;

    $(selCards.overlay).filter("[data-cardorder='" + prevCardOrder + "']").addClass("current");

    $(targetCardOverlay).hide().removeAttr("data-cardorder");

    hideAllCardLoadingSpinner();

    toggleBackButton();
}

//toggle back button visibility
function toggleBackButton() {
    if ($(selCards.visibleInnerCards).length > 1) {
        $(selCards.btnBackCard).show();
    } else {
        $(selCards.btnBackCard).hide();
    }
}

//remove individual cards
function removeCard(targetCardButton) {
    var targetPrompt = $(targetCardButton).data("prompt"),
        targetCard = $(targetCardButton).parents(selCards.cardItem);

    //add clase to mark card for deletion
    $(targetCard).addClass(selCards.removeFlag);

    var grpSelectedGuid = $("#loaded-group-guid").val();

    if (grpSelectedGuid == UnclassifiedGrpGuid)
        showPrompt(targetPrompt, ["{{RMVDEVALTMSG}}"], [promptsStrings.remDevAltMsgUnclassified]);
    else
        showPrompt(targetPrompt, ["{{RMVDEVALTMSG}}"], [promptsStrings.remDevAltMsg]);

    //show prompt with confirmation - prompts.js
    //if OK - remove() cards with flag
    //if Cancel - remove flag
    $(selCards.btnCommitRemove).data("guid", targetCardButton.data("guid"));
}

//remove multiple cards
function removeMultiCards(btnRemoveMultiCards) {
    var targetPrompt = $(btnRemoveMultiCards).data("prompt"),
        targetCards = $(selCards.selectedCard);

    $(targetCards).addClass(selCards.removeFlag);
    var grpSelectedGuid = $("#loaded-group-guid").val();

    if (grpSelectedGuid == UnclassifiedGrpGuid)
        showPrompt(targetPrompt, ["{{RMVDEVALTMSG}}"], [promptsStrings.remDevAltMsgUnclassified]);
    else
        showPrompt(targetPrompt, ["{{RMVDEVALTMSG}}"], [promptsStrings.remDevAltMsg]);

    $(selCards.btnCommitRemove).removeData("guid");
}

//completes remove operation
//used in prompts.js
function commitPendingRemovals() {
    GetCalbackObject(CardsCallbacks, null).fnRemoveCards($(selCards.cardsFlaggedForRemoval));

    $(selCards.cardsFlaggedForRemoval).attr("disabled", "disabled");
    updateSelectedCardsCount();
    hidePrompt();
}

//completes remove operation
//used in prompts.js
function commitDeviceRemoval(btn) {
    GetCalbackObject(CardsCallbacks, btn).fnRemoveCards($(btn));

    $(".card[data-guid=" + $(btn).data("guid") + "]").attr("disabled", "disabled");
    updateSelectedCardsCount();
    hidePrompt();
    closeCards();
}

//select all cards (even invisible)
function selectedCards(targetCardButton) {
    var targetCards = $(selCards.selectedCard);
    return targetCards;
}

//set device credentials
function setDeviceCredentials(opInit) {
    if (!$(selCards.devCredContainer).is(":visible")) {
        $(opInit).parents(selCards.cardFocusArea).next(selCards.devCredContainer).slideDown(200);
        $(opInit).hide();
    }
}

//close device credentials details
function closeDeviceCredentials(opInit) {
    if ($(selCards.devCredContainer).is(":visible")) {
        $(opInit).parents(selCards.devCredContainer).slideUp(200);
        $(opInit).parents(selCards.devCredContainer).prev(selCards.cardFocusArea).find(selCards.btnSetCredentials).show();
    }
}

//clear device credentials
function clearDeviceCredentials(opInit) {
    $(opInit).parents(selCards.devCredContainer).find("input").val("");
}

function isReportsGroupTreeActive() {
    if (($(".card-overlay.group-tree-card").is(":visible")) && ($(".full-card-overlay.report-card").is(":visible"))) {
        return true;
    }
    else {
        return false;
    }
}

function checkIfClickOnOverlay(clickedEl) {

    if (!(clickedEl.parents('.inner-card-container').length)) {

        if (isReportsGroupTreeActive()) {
            $(".group-tree-card").removeClass("current").hide();
            $(".report-card.full-card-overlay").addClass("current");
        }
        else {
            closeCards();
        }

    }
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
function toggleOpenGroupTreeButton(enabled) {
    if (enabled)
        $(selCards.btnOpnGrpCard).removeClass("disabled");
    else
        $(selCards.btnOpnGrpCard).addClass("disabled");
}

function toggleRemoveCardsButton(enabled) {
    if (enabled)
        $(selCards.btnRemoveCards).removeClass("disabled");
    else
        $(selCards.btnRemoveCards).addClass("disabled");
}

function InitialiseCards(containerSelector, callbacks) {
    if (CardsCallbacks.length == 0)
        CardsCallbacks = [{
            id: "",
            fnRemoveCards: function () { return true; },
            fnOpenPatchCard: function () { return true; },
            fnOpenDeviceCard: function () { return true; },
            fnOpenGroupsTreeCard: function () { return true; },
            fnBackCard: function () { return true; },
            fnCloseAllCards: function () { return true; },
            fnSubmitCredentials: function () { return true; },
            fnSendMessage: function () { return true; },
            fnShutdownDevice: function () { return true; },
            fnRebootDevice: function () { return true; },
            fnOpenNotificationCard: function () { return true; },
            fnOpenReportCard: function () { return true; },
            fnOpenThreatCard: function () { return true; },
            fnOpenAvExclusionsCard: function () { return true; },
            fnOpenAlertCard: function () { return true; },
            fnOpenTemporaryAccessCard: function () { return true; }
        }];

    CardsCallbacks = InitialiseCalbackObject(CardsCallbacks, callbacks);

    //close card
    $(containerSelector + " " + selCards.btnCloseCard).off("click");
    $(containerSelector + " " + selCards.btnCloseCard).on("click", function () {
        var thisItem = $(this);
        closeCards(thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnCloseAllCards();
    });

    $(containerSelector + " " + selCards.btnAddCard).off("click");
    $(containerSelector + " " + selCards.btnAddCard).on("click", function () {
        var thisItem = $(this);
        var targetPrompt = $(thisItem).data("prompt");
        showPrompt(targetPrompt, [""], [""]);
    });

    $(containerSelector + " " + selCards.btnRemoveCard).off("click");
    $(containerSelector + " " + selCards.btnRemoveCard).on("click", function () {
        var thisItem = $(this);
        removeCard(thisItem);
    });

    $(containerSelector + " " + selCards.btnRemoveCards).off("click");
    $(containerSelector + " " + selCards.btnRemoveCards).on("click", function () {
        var thisItem = $(this);
        if (thisItem.hasClass("disabled")) return;
        removeMultiCards(thisItem);
    });

    // close cards by clicking on overlay
    $(containerSelector + " " + selCards.cardContainer).off("click");
    $(containerSelector + " " + selCards.cardContainer).on("click", function (evt) {
        var clickedEl = $(evt.target);
        checkIfClickOnOverlay(clickedEl);
    });

    //confirm pending removals
    $(".prompt-overlay").off("click", selCards.btnCommitRemove);
    $(".prompt-overlay").on("click", selCards.btnCommitRemove, function () {
        if ($(this).data("guid") != null)
            commitDeviceRemoval($(this));
        else
            commitPendingRemovals();
    });

    //confirm pending removals
    $(".prompt-overlay").off("click", selCards.btnCommitAdd);
    $(".prompt-overlay").on("click", selCards.btnCommitAdd, function (element) {
        var location = ActionURLS.Devices.Download + "?controllerId=" + $('#downloadZipController').data('selected');
        $.ajax({
            async: true,
            type: 'GET',
            url: location,
        }).done(function (data, textStatus, jqXHR) {
            if (jqXHR.responseJSON) {
                if (data.Success !== "OK") {
                    console.log("Connecting to the controller failed: " + data.ErrorMsg);
                    alert("Connecting to the controller failed: " + data.ErrorMsg);
                }
            } else {
                window.location = location;
            }
        })
    });

    //changed dropdown
    $(".prompt-overlay").off("click", selFilters.filter);
    $(".prompt-overlay").on("click", selFilters.filter, function (element) {
        var serverAddress = $('#downloadZipController').data('selected');
        var command = $('#command').text();

        var tag = "SERVERADDRESS=";
        var sub = command.substr(command.indexOf(tag) + tag.length);
        command = command.replace(sub.substr(0, sub.indexOf('"')), serverAddress);

        $('#command').text(command);
    });

    //close current card
    //simulate back action
    $(containerSelector).off("click", selCards.btnBackCard);
    $(containerSelector).on("click", selCards.btnBackCard, function () {
        var thisItem = $(this);
        closeCard(thisItem);

        GetCalbackObject(CardsCallbacks, thisItem).fnBackCard();
    });

    //open device card
    $(containerSelector).off("click", selCards.btnOpnDevCard);
    $(containerSelector).on("click", selCards.btnOpnDevCard, function (e) {
        var thisItem = $(this);
        openCard(selCards.deviceCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenDeviceCard($(this).data("devicename"));
        e.stopPropagation();
    });

    //open alert card
    $(containerSelector).off("click", selCards.btnOpnAlertCard);
    $(containerSelector).on("click", selCards.btnOpnAlertCard, function (e) {
        var thisItem = $(this);
        openCard(selCards.alertCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenAlertCard($(this).data("cardid"));
        e.stopPropagation();
    });

    //open widget library card
    $(containerSelector).off("click", selCards.btnOpenWidgetLibraryCard);
    $(containerSelector).on("click", selCards.btnOpenWidgetLibraryCard, function () {
        var thisItem = $(this);
        openCard(selCards.widgetLibraryCard, thisItem);

    });

    //open patch card
    $(containerSelector).off("click", selCards.btnOpnPtcCard);
    $(containerSelector).on("click", selCards.btnOpnPtcCard, function (e) {
        var thisItem = $(this);
        openCard(selCards.patchCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenPatchCard($(this).data("pid"), true);
        e.stopPropagation();
    });

    //open threat card
    $(containerSelector).off("click", selCards.btnOpnThreatCard);
    $(containerSelector).on("click", selCards.btnOpnThreatCard, function (e) {
        var thisItem = $(this);
        openCard(selCards.threatCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenThreatCard($(this).data("kaspid"), $(this).text(), true);
        e.stopPropagation();
    });

    //open affected devices tab (patch management)
    $(containerSelector).off("click", selCards.btnShowAffectedDevices);
    $(containerSelector).on("click", selCards.btnShowAffectedDevices, function () {
        var thisItem = $(this);
        openCard(selCards.patchCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenPatchCard($(this).data("pid"), false);
    });

    //open affected devices tab (antivirus protection)
    $(containerSelector).off("click", selCards.btnShowAffectedDevicesThreat);
    $(containerSelector).on("click", selCards.btnShowAffectedDevicesThreat, function () {
        var thisItem = $(this);
        openCard(selCards.threatCard, thisItem);
    });


    //open report card
    $(containerSelector).off("click", selCards.btnOpnRepCard);
    $(containerSelector).on("click", selCards.btnOpnRepCard, function () {
        var thisItem = $(this);
        //$(this).data("reportname")
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenReportCard(thisItem);

        openCard(selCards.reportCard, thisItem);
    });

    //open device exclusions card
    $(containerSelector).off("click", selCards.btnOpenDevExcCard);
    $(containerSelector).on("click", selCards.btnOpenDevExcCard, function () {

        if (!IsAVCardEnabled()) return;

        var thisItem = $(this);
        var deviceGuid = $(thisItem).attr("data-guid");
        openCard(selCards.deviceExclusionCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenAvExclusionsCard(deviceGuid);

    });

    //open groups tree card
    $(containerSelector).off("click", selCards.btnOpnGrpCard);
    $(containerSelector).on("click", selCards.btnOpnGrpCard, function () {
        var thisItem = $(this);
        if (thisItem.hasClass("disabled")) return;
        openCard(selCards.groupTreeCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenGroupsTreeCard(this);
    });

    ////open notifications card in notification center
    //$(containerSelector).off("click", selCards.btnOpnNotCard);
    //$(containerSelector).on("click", selCards.btnOpnNotCard, function () {
    //    var thisItem = $(this);
    //    openCard(selCards.notificationCard, thisItem);
    //    CallbackOpenNotificationCard(this);
    //});

    //open notifications card from other cards
    $(containerSelector).off("click", selCards.btnOpenNotificationCard);
    $(containerSelector).on("click", selCards.btnOpenNotificationCard, function (e) {
        var thisItem = $(this);
        openCard(selCards.notificationCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenNotificationCard(this);
    });

    //set device credentials
    $(containerSelector).off("click", selCards.btnSetCredentials);
    $(containerSelector).on("click", selCards.btnSetCredentials, function () {
        var thisItem = $(this);
        setDeviceCredentials(thisItem);
    });

    //close device credentials
    $(containerSelector).off("click", selCards.btnCloseDeviceCredentials);
    $(containerSelector).on("click", selCards.btnCloseDeviceCredentials, function () {
        var thisItem = $(this);
        closeDeviceCredentials(thisItem);
    });

    //clear device credentials
    $(containerSelector).off("click", selCards.btnClearDeviceCredentials);
    $(containerSelector).on("click", selCards.btnClearDeviceCredentials, function () {
        var thisItem = $(this);
        clearDeviceCredentials(thisItem);
        $("#" + selCards.setCredConfirm).removeAttr("disabled");
    });

    //show message prompt
    $(containerSelector).off("click", selCards.btnMsgPrompt);
    $(containerSelector).on("click", selCards.btnMsgPrompt, function () {
        var targetPrompt = $(this).data("prompt");
        var deviceName = $(this).data("devname");

        if (deviceName != null)
            showPrompt(targetPrompt, ["{{deviceName/groupName}}"], [deviceName]);
        else
            showPrompt(targetPrompt, ["{{deviceName/groupName}}"], ["Device(s)"]);
    });

    //show reboot prompt
    $(containerSelector).off("click", selCards.btnRebootDevice);
    $(containerSelector).on("click", selCards.btnRebootDevice, function () {
        var targetPrompt = $(this).data("prompt");
        showPrompt(targetPrompt);
    });

    //confirm reboot prompt
    $(containerSelector).off("click", selCards.btnConfReboot);
    $(containerSelector).on("click", selCards.btnConfReboot, function () {
        hidePrompt();
    });

    //open Temporary access card
    $(containerSelector).off("click", selCards.btnOpenTempAccessCard);
    $(containerSelector).on("click", selCards.btnOpenTempAccessCard, function (e) {
        var thisItem = $(this);
        openCard(selCards.tempAccessCard, thisItem);
        GetCalbackObject(CardsCallbacks, thisItem).fnOpenTemporaryAccessCard();
        e.stopPropagation();
    });

    //show shutdown prompt
    $(containerSelector).off("click", selCards.btnShutdownDevice);
    $(containerSelector).on("click", selCards.btnShutdownDevice, function () {
        var targetPrompt = $(this).data("prompt");
        showPrompt(targetPrompt);
    });

    //confirm shutdown prompt
    $(containerSelector).off("click", selCards.btnConfShutdown);
    $(containerSelector).on("click", selCards.btnConfShutdown, function () {
        hidePrompt();
    });

    //start tour
    $(containerSelector).off("click", selCards.btnStartTour);
    $(containerSelector).on("click", selCards.btnStartTour, function () {
        startTour();
    });

    //initialise cards as draggable
    $(containerSelector + " .card.draggable").draggable({
        helper: "clone",
        opacity: 1,
        multiple: true,
        revert: "invalid",
        //cursor: "crosshair",
        cursorAt: {
            top: 15,
            right: 20
        },
        start: function () {

            //check if aside is collapsed
            asideClass = $("aside").hasClass("tree-collapsed");

            //show if true
            if (asideClass == true) {
                revealSidebarTree();
            }

            //add transparent class to draggable object
            //multidrag.js handles hiding and showing
            $(this).addClass("transparent");
        },
        stop: function () {

            //if aside was collapsed, re-collapse it
            if (asideClass == true) {
                hideSidebarTree();
            }

            //remove transoarent class
            $(this).removeClass("transparent");
        }
    });

    console.log("Init. Cards " + containerSelector);
}


    //////////////////////////////////////////////////////////////////////////////////////////////////////////////
